--------------------------------------------------------------------------------
--  *  Prog name PROJECTNAME.adb
--  *  Project name PROJECTNAME
--  *
--  *  Version 1.0
--  *  Last update DATE
--  *
--  *  Created by FULLUSERNAME on DATE.
--  *  Copyright (c) YEAR ORGANIZATIONNAME.
--  *  All rights reserved.
--  *    or (keep only one line or write your own)
--  *  GNAT modified GNU General Public License
--  *
--------------------------------------------------------------------------------

with CoreServices.CarbonCore.MacTypes; use type CoreServices.CarbonCore.
    MacTypes.OSStatus;
with CoreFoundation.CFBase;
with Carbon.HIToolbox.IBCarbonRuntime;
with Carbon.HIToolbox.MacWindows;
with ApplicationServices.QD.Quickdraw;
with Carbon.HIToolbox.CarbonEvents;

procedure PROJECTNAME is

    Nibref	: aliased Carbon.HIToolbox.IBCarbonRuntime.IBNibRef;
    window 	: aliased ApplicationServices.QD.Quickdraw.WindowRef;
    err 	: CoreServices.CarbonCore.MacTypes.OSStatus;
    Error   : exception;

begin
    -- Create a Nib reference passing the name of the nib file (without the .nib extension)
    -- CreateNibReference only searches into the application bundle.
    err := Carbon.HIToolbox.IBCarbonRuntime.CreateNibReference(
        CoreFoundation.CFBase.cStr("PROJECTNAME"), Nibref'access);
    if err /= 0 then
        raise Error;
    end if;

    -- Once the nib reference is created, set the menu bar. "MainMenu" is the name of the menu bar
    -- object. This name is set in InterfaceBuilder when the nib is created.
    err := Carbon.HIToolbox.IBCarbonRuntime.SetMenuBarFromNib(Nibref,
        CoreFoundation.CFBase.cStr("MenuBar"));
    if err /= 0 then
        raise Error;
    end if;

    -- Then create a window. "MainWindow" is the name of the window object. This name is set in 
    -- InterfaceBuilder when the nib is created.
    err := Carbon.HIToolbox.IBCarbonRuntime.CreateWindowFromNib(Nibref,
        CoreFoundation.CFBase.cStr("MainWindow"), window'access);
    if err /= 0 then
        raise Error;
    end if;

    -- We don't need the nib reference anymore.
    Carbon.HIToolbox.IBCarbonRuntime.DisposeNibReference(Nibref);

    -- The window was created hidden so show it.
    Carbon.HIToolbox.MacWindows.ShowWindow( window );

    -- Call the event loop
    Carbon.HIToolbox.CarbonEvents.RunApplicationEventLoop;
end PROJECTNAME;

