--------------------------------------------------------------------------------
--  *  Prog name PROJECTNAME.adb
--  *  Project name PROJECTNAME
--  *
--  *  Version 1.0
--  *  Last update DATE
--  *
--  *  Created by FULLUSERNAME on DATE.
--  *  Copyright (c) YEAR ORGANIZATIONNAME.
--  *  All rights reserved.
--  *    or (keep only one line or write your own)
--  *  GNAT modified GNU General Public License
--  *
--  * NOTES with Ada Carbon API of October 2002
--  *
--------------------------------------------------------------------------------

With CoreServices.Carboncore.MacTypes;
Use CoreServices.Carboncore.MacTypes;
With CoreServices.Carboncore.Gestaltequ;
Use CoreServices.Carboncore.Gestaltequ;
With Carbon.HIToolBox.MacWindows;
Use Carbon.HIToolBox.MacWindows;
With Carbon.HIToolBox.Processes;
Use Carbon.HIToolBox.Processes;
With Carbon.HIToolBox.Events;
Use Carbon.HIToolBox.Events;
With Carbon.HIToolBox.Menus;
Use Carbon.HIToolBox.Menus;
With Carbon.HIToolBox.Controls;
Use Carbon.HIToolBox.Controls;
With Carbon.HIToolBox.Dialogs;
Use Carbon.HIToolBox.Dialogs;
With Carbon.HIToolBox.AEInteraction;
Use Carbon.HIToolBox.AEInteraction;
With ApplicationServices.Ae.AEDataModel;
Use ApplicationServices.Ae.AEDataModel;
With ApplicationServices.Ae.AppleEvents;
Use ApplicationServices.Ae.AppleEvents;
With ApplicationServices.qd.Quickdraw;
Use ApplicationServices.qd.Quickdraw;
With Pstrings;
Use Pstrings;

With PROJECTNAMEASIDENTIFIER_events;
Use PROJECTNAMEASIDENTIFIER_events;

Procedure PROJECTNAME Is 

    -- main.h 

    RMenuBar : Constant := 128; -- menu bar   
    MApple   : Constant := 128; -- Apple menu   
    IAbout   : Constant := 1;  

    MFile          : Constant := 129; -- File menu   
    INew           : Constant := 1;  
    IClose         : Constant := 4;  
    IQuitSeparator : Constant := 10;  
    IQuit          : Constant := 11;  

    MEdit     : Constant := 130; -- Edit menu   
    KAboutBox : Constant := 200; -- Dialog resource for About box   

    Procedure initialize; -- function prototypes
    Procedure EventLoop; 
    Procedure MakeWindow; 
    Procedure MakeMenu; 
    Procedure DoEvent (
          event : Access EventRecord ); 
    Procedure DoMenuCommand (
          MenuResult : Long_Integer ); 
    Procedure DoAboutBox; 
    Procedure DrawWindow (
          window : WindowRef ); 

    Procedure initialize Is -- Initialize some managers
        err : OSErr;  

    Begin
        InitCursor;

        err := AEInstallEventHandler( To_OSType(kCoreEventClass),
            To_OSType(
                kAEQuitApplication),
            NewAEEventHandlerUPP(PROJECTNAMEASIDENTIFIER_events.QuitAppleEventHandler'Access),
            0, False );
        If (err /= noErr) Then
            ExitToShell;
        End If;
    End;

    Procedure EventLoop Is 
        GotEvent : Boolean;  
        event    : Aliased EventRecord;  

    Begin
        GQuitFlag := False;
        Loop
            GotEvent := Boolean(WaitNextEvent(everyEvent,event'Access,
                    32767,Null));
            If GotEvent Then
                DoEvent(event'Access);
            End If;
            Exit When GQuitFlag;
        End Loop;
        ExitToShell;
    End;

    Procedure MakeWindow Is -- Put up a window
        WRect    : Aliased rect;  
        MyWindow : WindowRef;  

    Begin
        SetRect(WRect'Access,50,50,600,200); -- left, top, right, bottom
        MyWindow := NewCWindow(Null, WRect'Access, To_Pascal("Hello"),
            True, zoomNoGrow,
            Frontmost, True, 0);

        If (MyWindow /= Null) Then
            SetPort(GetWindowPort(MyWindow));  -- set port to new window
        Else
            ExitToShell;
        End If;
    End;

    Procedure MakeMenu Is 	-- Put up a menu
        MenuBar  : Handle;  
        menu     : MenuRef;  
        response : Aliased Mod32;  
        err      : OSErr;  

    Begin
        MenuBar := GetNewMBar(RMenuBar);	-- read menus into menu bar
        If ( MenuBar /= Null ) Then
            SetMenuBar(MenuBar);	-- install menus
            -- AppendResMenu(GetMenuHandle(mApple), 'DRVR');

            err := Gestalt(To_OSType(gestaltMenuMgrAttr), response'Access);
            If (err = noErr) And Then (response And
                    gestaltMenuMgrAquaLayoutMask) /=
                    0 Then
                menu := GetMenuHandle( MFile );
                DeleteMenuItem( menu, IQuit );
                DeleteMenuItem( menu, IQuitSeparator );
            End If;

            DrawMenuBar;
        Else
            ExitToShell;
        End If;
    End;

    Procedure DoEvent (
          event : Access EventRecord ) Is 
        part        : SInt16;  
        hit         : Boolean;  
        key         : Character;  
        TempRect    : Aliased rect;  
        WhichWindow : Aliased WindowRef;  
        Dum         : RectPtr;  
        St          : OSStatus;  
        StErr       : OSErr;  

    Begin
        Case event.what Is
            When mouseDown =>
                part := FindWindow(event.where, WhichWindow'Access);
                Case part Is
                    When inMenuBar =>  -- process a moused menu command
                        DoMenuCommand(MenuSelect(event.where));

                    When inSysWindow =>
                        Null;

                    When inContent =>
                        If (WhichWindow /= FrontWindow) Then
                            SelectWindow(WhichWindow);
                        End If;

                    When inDrag =>	-- pass screenBits.bounds
                        Dum := GetRegionBounds(GetGrayRgn, TempRect'Access);
                        DragWindow(WhichWindow, event.where, TempRect'Access);

                    When inGrow =>
                        Null;

                    When inGoAway =>
                        DisposeWindow(WhichWindow);
                        ExitToShell;

                    When inZoomIn | inZoomOut =>
                        hit := Boolean(TrackBox(WhichWindow, event.where,
                                part));
                        If (hit) Then
                            SetPort(GetWindowPort(WhichWindow));
                            -- window must be current port
                            EraseRect(GetWindowPortBounds(WhichWindow,
                                    TempRect'Access));
                            -- inval/erase because of ZoomWindow bug
                            ZoomWindow(WhichWindow, part, True);
                            St := InvalWindowRect(WhichWindow,
                                GetWindowPortBounds(
                                    WhichWindow, TempRect'Access));
                        End If;
                    When Others =>
                        Null;
                End Case;

            When keyDown | autoKey =>
                key := Character'Val(To_Mod32(Long_Integer(event.message)) And
                    charCodeMask);
                If (To_Mod16(Short_Integer(event.modifiers)) And cmdKey) /=
                        0 Then
                    If (event.what = keyDown) Then
                        DoMenuCommand(MenuKey(key));
                    End If;
                End If;
            When activateEvt =>	       -- if you needed to do something special
                Null;

            When updateEvt =>
                DrawWindow(WindowRef (Carbon.HIToolBox.MacWindows.Convert(
                            Integer(
                                event.message))));

            When kHighLevelEvent =>
                StErr := AEProcessAppleEvent( event );

            When diskEvt =>
                Null;
            When Others =>
                Null;
        End Case;
    End;

    Procedure DoMenuCommand (
          MenuResult : Long_Integer ) Is 
        menuID   : Mod16; -- the resource ID of the selected menu  
        menuItem : Mod16; -- the item number of the selected menu  

        Function LoWord (
              Val : Mod32 ) 
          Return Mod16 Is 
        Begin
            Return Mod16(Val And 16#0000FFFF#);
        End LoWord;

        Function HiWord (
              Val : Mod32 ) 
          Return Mod16 Is 
        Begin
            Return Mod16((Val And 16#FFFF0000#) / 65536);
        End HiWord;

    Begin
        menuID := HiWord(To_Mod32(MenuResult));
        -- use macros to get item & menu number
        menuItem := LoWord(To_Mod32(MenuResult));

        Case menuID Is
            When MApple =>
                Case menuItem Is
                    When IAbout =>
                        DoAboutBox;


                    When IQuit =>
                        ExitToShell;


                    When Others =>
                        Null;
                End Case;

            When MFile =>
                Null;

            When MEdit =>
                Null;
            When Others =>
                Null;
        End Case;
        HiliteMenu(0);	-- unhighlight what MenuSelect (or MenuKey) hilited
    End;

    Procedure DrawWindow (
          window : WindowRef ) Is 
        TempRect : Aliased rect;  
        CurPort  : Aliased GrafPtr;  

    Begin
        GetPort(CurPort'Access);
        SetPort(GetWindowPort(window));
        BeginUpdate(window);
        EraseRect(GetWindowPortBounds(window, TempRect'Access));
        DrawControls(window);
        DrawGrowIcon(window);
        EndUpdate(window);
        SetPort(CurPort);
    End;

    Procedure DoAboutBox Is 
        Dum : DialogItemIndex;  
    Begin
        Dum := Alert(KAboutBox, Null);  -- simple alert dialog box
    End;

Begin
    initialize;
    MakeWindow;
    MakeMenu;
    EventLoop;
End PROJECTNAME;
